{$l-}
{ tasking error codes }
  const
    tcberr = 30 ; {id does not have a valid tcb}
    invpri = 31 ; {invalid priority number}
    notask = 32 ; {invalid call to primitive}
    initer = 33 ; {must have at least one task}
    nocnt = 34 ; {zero await count}
    srnger = 35 ; {task system stack range error}
    urnger = 36 ; {task user stack range error}
    
{ task control block definition }
  type
    tcb = record
            id          : byte ;
            timeslice   : byte ;
            status      : byte ;
            priority    : #1 .. #255 ;
            prior_count : byte ;
            stack_ptr   : hex ;
            task_bos    : hex ;
            task_tos    : hex ;
            task_bou    : hex ;
            task_tou    : hex ;
            next_event  : ^tcb ;
            prev_event  : ^tcb ;
            count       : ^byte ;
            timeout     : 0 .. maxint ;
            next_time   : ^tcb ;
            prev_time   : ^tcb ;
            msg_id      : byte ;
            msg_ret_id  : byte ;
            message     : hex 
          end ;
{$l+}
