module pfcall {$v3,0 procedure and function calls} ;
{
  5/17/89 : initial conversion to level 3
}
{$I/r0/token}
{$I/r0/code}
{$I/r0/error}
{$I/r0/varib}
{$I/r0/codeproc}

  procedure scan ; external ;
  function get_next (p1 : ^token_type ; first : boolean) : ^token_type ; external ;
  function varib (vpac : ^packet ; var verror : error_type ;
                  getdata : boolean ; outer : boolean) : ^packet ; external ;
  function gimme (req : tokes ; var gerror : error_type) : ^packet ; external ;
  procedure uncon (p : ^packet) ; external ;
  procedure push (p : ^packet) ; external ;
  procedure pull (p : ^packet) ; external ;
  function get_packet (sympt : ^symhead) : ^packet ; external ;

  function pfcall (var gerror : error_type ; p : ^symhead ;
                   fflag : boolean) : ^token_type ;
    var
      p1 : ^symhead ;
      p2 : ^token_type ;
      p3 : ^longhex ;
      p4 : ^proc_head ;
      p6 : ^packet ;
      d, s : manypt ;
      pcount : byte ;
      heapsave : longhex ;
      varflag : boolean ;
      psave : array [#0 .. #35] of ^symhead ;
    begin
      gerror := undef ;
      p4 := p + align(sizeof(symhead)) ;
      if p4^.comp_status in [proc_in_comp, proc_forward, proc_exc_in]
        then
          begin {compress}
            heapsave := heapptr ;
            p1 := last_sym ;
            pcount := 0 ;
            repeat
              if p1 = p
                then
                  exit ;
              if p1^.idgroup = vardef
                then
                  begin
                    p2 := p1 + align(sizeof(symhead)) ;
                    if p2^ in [varibpar, valuepar, funcret]
                      then
                        begin
                          p3 := align(p2 + 1) ;
                          if p3^ = p
                            then
                              begin {have parameter}
                                pcount := pcount + 1 ;
                                psave [pcount] := p1
                              end
                        end
                  end ;
              p1 := p1^.nextptr
            until false ;
            d.tk := heapptr ;
            while pcount <> 0 do
              begin
                p1 := psave[pcount] ;
                pcount := pcount - 1 ;
                s.tk := p1 + align(sizeof(symhead)) ;
                d.tk^ := s.tk^ ;
                d.tk := d.tk + 1 ;
                s.tk := align(s.tk + 1) + 4 ;
                s.tk := get_next (s.tk, true) ;
                d.tk^ := s.tk^ ;
                case d.tk^ of
                  arrayvar, recordvar, devicevar :
                    begin
                      d.tk := align(d.tk + 1) ;
                      s.tk := align(s.tk + 1) ;
                      d.hx^ := s.hx^ ;
                      d.lx := d.lx + 2
                    end ;
                  stringvar, setvar :
                    begin
                      d.tk := d.tk + 1 ;
                      s.tk := s.tk + 1 ;
                      d.ch^ := s.ch^ ;
                      d.tk := d.tk + 1
                    end ;
                  subbool .. sublint :
                    begin
                      d.ch^ := d.ch^ - sub_offset ;
                      d.tk := d.tk + 1
                    end
                  else
                    d.tk := d.tk + 1
                end
              end ; {while}
            d.tk^ := termit ;
            heapptr := align(d.tk + 1) ;
            d.tk := heapsave ; {start of parameters}
          end {compress}
        else
          d.tk := p4 + align(longhex(sizeof(proc_head))) ;
      repeat {for error exits only}
        if d.tk^ in [valuepar, varibpar]
          then
            begin {have parameters}
              scan ;
              if lastpack^.token <> leftparen
                then
                  begin
                    gerror := e_npnd ;
                    exit
                  end ;
              repeat {parameters}
                varflag := d.tk^ = varibpar ;
                d.tk := d.tk + 1 ;
                scan ;
                if varflag
                  then
                    begin
                      p6 := varib(lastpack, gerror, false, true) ;
                      if gerror <> undef
                        then
                          exit(2) ;
                      if d.tk^ <> p6^.token
                        then
                          if enum(byte(p6^.token) - sub_offset) <> d.tk^
                            then
                              begin
                                gerror := e_tc ;
                                exit (2)
                              end ;
                      opcode (c_pshu) ;
                      post1t (p_ipx)
                      {pshu x}
                    end
                  else
                    begin {expression}
                      p6 := gimme([d.tk^], gerror) ;
                      if gerror <> undef
                        then
                          exit (2) ;
                      uncon (p6) ;
                      push (p6) ;
                      if p6^.token = devicevar
                        then
                          begin
                            gerror := e_fpna ;
                            exit (2)
                          end
                    end ;
                case d.tk^ of
                  devicevar :
                    d.tk := align(d.tk + 1) + 2 ;
                  arrayvar, recordvar :
                    begin
                      d.tk := align(d.tk + 1) ;
                      if (p6^.size = d.hx^) or
                         (varflag and (p6^.size <= d.hx^))
                        then
                          d.lx := d.lx + 2
                        else
                          begin
                            d.lx := d.lx + 2 ;
                            gerror := e_ips ;
                            exit (2)
                          end
                    end ;
                  stringvar, setvar :
                    begin
                      d.ch := d.ch + 1 ;
                      if not varflag
                        then
                          begin
                            hand (int, $27) ;
                            datat_byte (d.ch^)
                          end ;
                      d.ch := d.ch + 1
                    end
                  else
                    d.tk := d.tk + 1
                end ; {case}
                if d.tk^ in [funcret, termit]
                  then
                    exit ;
                if lastpack^.token <>  comma
                  then
                    begin
                      gerror := e_npnd ;
                      exit (2)
                    end
              until false ;
              if lastpack^.token <> rightparen
                then
                  begin
                    gerror := e_npnd ;
                    exit
                  end
            end ; {parameters}
        scan ;
        if p^.lexlev <> 2
          then
            ldaim (lex - p^.lexlev) ;
            {lda #lexdifference}
        case p4^.comp_status of
          proc_absolute :
            begin
              opcode (c_jsr) ;
              post1 (p_abs) ;
              codet_word (p^.offset)
              {jsr $address}
            end ;
          proc_external :
            begin
              opcode (c_xbxx) ;
              post1 (p_bsr + p_rell + p_reex) ;
              labt (p^.nameptr^)
              {lbsr name}
            end ;
          proc_except : gerror := e_ecc
          else
            begin
              opcode (c_xbxx) ;
              post1 (p_bsr + p_rell) ;
              codet_word (p^.intname)
              {lbsr lbxxxx}
            end
        end {case}
      until true ;
      pfcall := d.tk
    end ;
    
  procedure proc_call (var gerror : error_type ; p : ^symhead) ; entry ;
    var
      dummy : longhex ;
    begin
      dummy := pfcall(gerror, p, false)
    end ;
    
  function func_call (var gerror : error_type ; p : ^symhead) : ^packet
                                                     ; entry ;
    var
      p1 : ^token_type ;
      p2 : ^packet ;
    begin
      p1 := pfcall(gerror, p, true) ;
      if gerror = undef
        then
          begin
            p1 := p1 + 1 ; {skip to token type}
            if p1^ in [subbool .. sublint]
              then
                p1^ := enum(byte(p1^)-sub_offset) ;
            p2 := get_packet(p1) ;
            if p2^.token = boolvar
              then
                begin
                  opcode (c_ldb) ;
                  post1t (p_idx + p_ixru + p_ixp)
                  {ldb 0,u+}
                end
              else
                pull (p2) ;
            func_call := p2
          end
    end ;
modend.
