module procs {$v3,0 procedure and function declarations} ;
{
  5/17/89 : initial conversion to level 3
}
{$I/r0/token}
{$I/r0/code}
{$I/r0/error}
{$I/r0/varib}
{$I/r0/codeproc}

  procedure scan ; external ;
  procedure errorpt (e : error_type) ; external ;
  procedure error (e : error_type) ; external ;
  function enter_symbol (s : string[120] ; restrict : boolean ;
                         var headaddr : ^symhead) : boolean ; external ;
  procedure semilook (e : error_type) ; external ;
  function get_internal : hex ; external ;
  procedure replace (e : error_type ; t : token_type) ; external ;
  procedure typeit (var p : manypt ; var errcode : error_type) ; external ;
  function allocate (st : storage_type) : error_type ; external ;
  function constant (var cerror : error_type) : ^packet ; external ;
  function retadr (pin : ^packet) : ^packet ; external ;
  function get_next (p1 : ^token_type ; first : boolean) : ^token_type ; external ;
  procedure skiperror (e : error_type ; toke : tokes) ; external ;
  procedure scanf ; external ;
  function module_check : boolean ; external ;
  procedure enum_up ; external ;
  procedure point_check ; external ;
  procedure goto_check ; external ;
  procedure block (prc : ^symhead) ; external ;
  function put_point (var old : ^symname ; current : ^symhead)
                                    : error_type ; external ;

  procedure proc_decl (var blk : hex ; var jump_flag : boolean ;
                                       func_flag : boolean) ; entry ;
    const
      notforward = 1 ;
      looklist   = 2 ;
      lookepar   = 3 ;
      pardone    = 4 ;
      parend     = 5 ;
      compress   = 6 ;
      pdone      = 7 ;
      look_semi_rpar = 8 ;
      a_looklist   = 12 ;
      a_lookepar   = 13 ;
      a_pardone    = 14 ;
      a_parend     = 15 ;
      a_compress   = 16 ;
      a_pdone      = 17 ;
      a_look_semi_rpar = 18 ;
    label
      notforward, looklist, lookepar, pardone, parend, 
      compress, pdone, look_semi_rpar,
      a_looklist, a_lookepar, a_pardone, a_parend,
      a_compress, a_pdone, a_look_semi_rpar ;
    var
      fwdflag : (none, nopar, par) ;
      proc_point, fwdlast, fwdsave, lastgood : ^symhead ;
      fwdnext : ^symname ;
      p1 : ^symhead ;
      p2 : ^token_type ;
      p3 : ^longhex ;
      p4 : ^proc_head ;
      p5 : ^symname ;
      p6 : ^packet ;
      p7 : ^byte ;
      d, s : manypt ;
      perror : error_type ;
      fsize, oldalloc, falloc : hex ;
      pcount : byte ;
      varflag, is_fast : boolean ;
      psave : array [#0 .. #35] of ^symhead ;
      ptactive, oldptactive : ^byte ;
      is_except : boolean register ;
    begin
      if false
        then
          begin
{
  this is to get around the severe limitation of number of
  forward declared goto's in the cross compiler
}
looklist :        goto a_looklist ;
lookepar :        goto a_lookepar ;
pardone :         goto a_pardone ;
parend :          goto a_parend ;
compress :        goto a_compress ;
pdone :           goto a_pdone ;
look_semi_rpar :  goto a_look_semi_rpar
          end ;
      fsize := 0 ;
      perror := undef ;
      oldalloc := alloc ;
      alloc := 0 ;
      fwdflag := none ;
      is_except := false ;
      if not module_check
        then
          begin
            override := true ;
            scanf ;
            override := false
          end ;
      lex := succ(lex) ;
      scan ; {get proc name}
      if not ident_flag
        then
          begin
            errorpt (e_id) ;
            goto looklist
          end ;
      if enter_symbol (last_ident, true, p1)
        then
          begin {maybe forward}
            p2 := p1 + align(sizeof(symhead)) ;
            if not (p1^.idgroup in [procdef, funcdef])
              then
                if p1^.idgroup = vardef
                  then
                    if p2^ <> funcret
                      then
                        begin
notforward :
                          errorpt (e_iddt) ;
                          goto looklist
                        end
                      else
                        begin
                          p3 := align (p2 + 1) ;
                          p1 := p3^ {point to symhead}
                        end
                  else
                    goto notforward ;
            proc_point := p1 ;
            p4 := p1 + align(sizeof(symhead)) ;
            if p4^.comp_status <> proc_forward
              then
                goto notforward ;
            fsize := p4^.func_size ;
            p4^.comp_status := proc_in_comp ;
            block_name := p1^.intname + 1 ;
{ restore parameter names to positive first character }
            p1 := last_sym ;
            repeat
              if p1 = proc_point
                then
                  exit ;
              if (p1^.idgroup = vardef) and (p1^.lexlev = lex)
                then
                  begin
                    p2 := p1 + align(sizeof(symhead)) ;
                    if p2^ in [varibpar, valuepar, funcret]
                      then
                        begin
                          p3 := align(p2 + 1) ;
                          if p3^ = proc_point
                            then
                              p1^.nameptr^[1] := p1^.nameptr^[1] and $7f
                        end
                  end ;
              p1 := p1^.nextptr
            until false ;
            scan ;
            if lastpack^.token <> semicolon
              then
                semilook (e_semi) ;
            scan ;
            goto parend
          end ; {forward}
      proc_point := p1 ;
      p1^.intname := get_internal ;
      block_name := get_internal ;
      if func_flag
        then
          p1^.idgroup := funcdef
        else
          p1^.idgroup := procdef ;
      p4 := p1 + align(sizeof(symhead)) ;
      p4^.param_size := 0 ;
      p4^.func_size := 0 ;
      p4^.comp_status := proc_in_comp ;
      d.tk := p4 + longhex(sizeof(proc_head)) ;
      d.tk^ := termit ;
      last_sym := p1 ;
      next_sym := align (d.tk + 1) ;
a_looklist :
      scan ;
      if lastpack^.token <> leftparen
        then
          goto lookepar ;
      repeat {parameter declaration}
        varflag := false ;
        scan ;
        if lastpack^.token = var_
          then
            begin
              varflag := true ;
              scan
            end ;
        var_active := var_start ;
        repeat {parameter names}
          if ident_flag
            then
              if not enter_symbol(last_ident, true, p1)
                then
                  begin
                    if (var_active + longhex(last_ident[0] + 1))
                      > (addr(varq) + longhex(size_varq))
                      then
                        begin
                          perror := e_vqf ;
                          goto look_semi_rpar
                        end ;
                    var_active^ := last_ident ;
                    var_active := var_active + longhex(last_ident[0]+1)
                  end
                else
                  begin
                    perror := e_iddt ;
                    goto look_semi_rpar
                  end
            else
              begin
                perror := e_id ;
                goto look_semi_rpar
              end ;
          scan ;
          if lastpack^.token <> comma
            then
              exit ; {have all the names}
          scan
        until false ; {name list}
        if not (lastpack^.token in [equal, colon, assign])
          then
            begin
              perror := e_colon ;
              goto look_semi_rpar
            end ;
        if lastpack^.token <> colon
          then
            replace (e_colon, colon) ;
        if var_active = var_start
          then
            begin {must have a least one name}
              perror := e_id ;
              goto look_semi_rpar
            end ;
        var_current := var_start ;
        if enter_symbol (var_current^, true, p1)
          then
            begin
              perror := e_iddt ;
              goto look_semi_rpar
            end ;
        p1^.idgroup := vardef ;
        d.tk := p1 + align(sizeof(symhead)) ;
        tpstart := d.tk ;
        if varflag
          then
            d.tk^ := varibpar
          else
            d.tk^ := valuepar ;
        d.tk := align(d.tk + 1) ;
        perror := undef ;
        d.lx^ := proc_point ;
        d.lx := d.lx + 4 ;
        ptactive := pointer_active ;
        typeit (d, perror) ;
        if perror <> undef
          then
            goto look_semi_rpar ;
        d.tk^ := termit ;
        tpend := d.tk ;
        oldptactive := ptactive ;
        repeat
          last_sym := p1 ;
          next_sym := align(d.tk + 1) ;
          perror := allocate(s_stack) ;
          if perror <> undef
            then
              goto look_semi_rpar ;
          var_current := var_current + longhex(var_current^[0] + 1);
          if var_current >= var_active
            then
              exit ;
          if enter_symbol (var_current^, true, p1)
            then
              begin
                perror := e_iddt ;
                goto look_semi_rpar
              end ;
          p1^.idgroup := vardef ;
          d.ch := p1 + align(sizeof(symhead)) ;
{ copy type declaration}
          p7 := tpstart ;
          while p7 <= tpend do
            begin
              d.ch^ := p7^ ;
              d.ch := d.ch + 1 ;
              p7 := p7 + 1
            end ;
          d.ch := d.ch - 1 ;
          perror := put_point(oldptactive, p1 + 6) ;
          if perror <> undef
            then
              goto look_semi_rpar
        until false ; {until all names in}
        enum_up ;
        if lastpack^.token <> semicolon
          then
            exit ; {not another parameter}
        if false
          then
            begin
a_look_semi_rpar :
              skiperror (perror, [semicolon, rightparen]) ;
              if lastpack^.token = rightparen
                then
                  exit
                else
                  if lastpack^.token <> semicolon
                    then
                      begin
                        errorpt (e_rpar) ;
                        exit
                      end
            end
      until false ; {done with parameters}
      if lastpack^.token <> rightparen
        then
          errorpt (e_rpar) ;
      scan ;
      point_check ;
a_lookepar :
      if lastpack^.token = colon
        then
          if func_flag
            then
              begin {function return type specification}
                p5 := next_sym ;
                p5^ := proc_point^.nameptr^ ; {copy function name}
                p1 := align(p5 + longhex(p5^[0] + 1)) ;
                p1^.nameptr := p5 ;
                p1^.nextptr := last_sym ;
                p1^.offset := 0 ;
                p1^.intname := 0 ;
                p1^.lexlev := lex ;
                p1^.storage := s_stack ;
                p1^.idgroup := vardef ;
                d.tk := p1 + align(sizeof(symhead)) ;
                d.tk^ := funcret ;
                d.tk := align(d.tk + 1) ;
                d.lx^ := proc_point ;
                d.lx := d.lx + 4 ;
                perror := undef ;
                typeit (d, perror) ;
                if perror <> undef
                  then
                    begin
                      semilook(perror) ;
                      goto pardone
                    end ;
                d.tk^ := termit ;
                last_sym := p1 ;
                next_sym := align(d.tk + 1) ;
                falloc := alloc ;
                perror := allocate(s_stack) ;
                if perror <> undef
                  then
                    begin
                      semilook(perror) ;
                      goto pardone
                    end ;
                enum_up ;
                fsize := alloc - falloc ;
                if fsize > 127
                  then
                    error (e_ifrt) ;
                if dyno
                  then
                    fsize := 0 - fsize ;
                if lastpack^.token <> semicolon
                  then
                    semilook (e_semi)
              end {function return}
            else
              semilook (e_semi)
        else {not a colon}
          if lastpack^.token = semicolon
            then
              if func_flag
                then
                  semilook (e_colon)
                else
            else
              semilook (e_semi) ;
a_pardone :
      if alloc > $7fe0
        then
          error (e_sao) ;
      point_check ;
      heapptr := heapstart ;
      p4 := proc_point + align(sizeof(symhead)) ;
      p4^.param_size := alloc ;
      p4^.func_size := fsize ;
      scan ;
      case lastpack^.token of
        external_ :
          begin
            passt (concat(' xref ',substr(proc_point^.nameptr^,1,8))) ;
            p4^.comp_status := proc_external ;
            if debug_opt and debug_en
              then
                begin
                  debug (1) ; {external proc}
                  code_word (proc_point^.intname + 1) ;
                  if p4^.func_size > $8000
                    then
                      code_word (p4^.param_size + p4^.func_size)
                    else
                      code_word (p4^.param_size - p4^.func_size) ;
                  debname (proc_point^.nameptr^) ;
                  outterm
                end ;
            scan ;
            if lex <> 2
              then
                error (e_will) ;
            goto compress
          end ;
        at_ :
          begin
            p6 := retadr (constant(perror)) ;
            if perror <> undef
              then
                begin
                  semilook (e_ita) ;
                  goto compress
                end ;
            p4^.comp_status := proc_absolute ;
            proc_point^.offset := p6^.pvc_hex ;
            goto compress
          end ;
        forward_ :
          begin
            p4^.comp_status := proc_forward ;
{ set parameter names to negative first character to avoid a match}
            p1 := last_sym ;
            repeat
              if p1 = proc_point
                then
                  exit ;
              if (p1^.idgroup = vardef) and (p1^.lexlev = lex)
                then
                  begin
                    p2 := p1 + align(sizeof(symhead)) ;
                    if p2^ in [varibpar, valuepar, funcret]
                      then
                        begin
                          p3 := align(p2 + 1) ;
                          if p3^ = proc_point
                            then
                              p1^.nameptr^[1] := p1^.nameptr^[1] or $80
                        end
                  end ;
              p1 := p1^.nextptr
            until false ;
            scan ;
            if lastpack^.token <> semicolon
              then
                semilook (e_semi) ;
            goto pdone
          end
      end ; {case}
a_parend :
      if debug_opt and debug_en
        then
          begin
            debug (7) ;
            post1t (lex)
          end ;
      if not jump_flag
        then
          begin
            jump_flag := true ;
            if not (c_module and (blk = $FFFF))
              then
                begin
                  opcode (c_xbxx) ;
                  post1 (p_bra + p_rel + p_rell) ;
                  codet_word (blk) ; {bra lbxxx}
                end
          end ;
      if lastpack^.token in [entry_,interrupt_,firq_,task_]
        then
          begin
            passt (concat(' xdef ',substr(proc_point^.nameptr^,1,8))) ;
            opcode (c_equ) ;
            post1 (p_eqep) ;
            labt (proc_point^.nameptr^) ;
            {name equ *}
            if lex <> 2
              then
                error (e_will) ;
            if lastpack^.token in [interrupt_, firq_]
              then
                begin
                  is_except := true ;
                  is_fast := lastpack^.token = firq_ ;
                  p4^.comp_status := proc_exc_in ;
                  if fsize <> 0
                    then
                      error (e_etnf)
                end ;
            if lastpack^.token = task_
              then
                intask := true ;
            scan ;
            if lastpack^.token = semicolon
              then
                scan
              else
                begin
                  semilook (e_semi) ;
                  goto pdone
                end
          end ;
      opcode (c_equ) ;
      post1 (p_eqlp) ;
      codet_word (proc_point^.intname) ;
      {lbxxx equ *}
      if is_except
        then
          begin
            if is_fast
              then
                begin
                  opcode (c_irq) ;
                  post1t (p_save)
                  {pshs u,y,x,d}
                end ;
            passt (' xref global') ;
            opcode (c_irq) ;
            post1t (p_ldy) ;
            {ldy global}
            opcode (c_pshu) ;
            post1t (p_ips + p_ipy) ;
            {pshu s,y}
            opcode (c_ldx) ;
            post1 (p_idx + p_ixry + p_ixfx) ;
            codet_word (-8) ;
            {ldx -8,y}
            opcode (c_pshu) ;
            post1t (p_ipy + p_ipx + p_ipd) ;
            {pshu y,x,d}
            opcode (c_irq) ;
            post1t (p_leay)
            {leay 10,u}
          end ;
      block (proc_point) ;
      p4 := proc_point + align(sizeof(symhead)) ;
      if debug_opt and debug_en
        then
          begin
            debug (2) ; {procedure end}
            code_word (proc_point^.intname + 1) ;
            debname (proc_point^.nameptr^) ;
            outterm
          end ;
      if is_except
        then
          begin
            if is_fast
              then
                begin
                  opcode (c_irq) ;
                  post1t (p_rest)
                  {puls u,y,x,d}
                end ;
            opcode (c_irq) ;
            post1t (p_rti)
            {rti}
          end
      else if intask and (lex = 2)
        then
          begin {terminate task}
            hand (ibra, $53) ;
            intask := false
          end
        else
          if fsize <> 0
            then
              begin
                hand (int, $10) ;
                data_word (p4^.param_size) ;
                if fsize > $7fff
                  then
                    datat_byte (-1)
                  else
                    datat_byte (byte(fsize))
              end
            else
              begin
                lddim (p4^.param_size) ;
                hand (ibra, $22)
              end ;
      goto_check ;
a_compress :
      pcount := 0 ;
      lastgood := next_sym ;
      p1 := last_sym ;
      repeat
        if p1 = proc_point
          then
            exit ;
        if (p1^.idgroup = vardef) and (p1^.lexlev = lex)
          then
            begin
              p2 := p1 + align(sizeof(symhead)) ;
              if p2^ in [varibpar, valuepar, funcret]
                then
                  begin
                    p3 := align (p2 + 1) ;
                    if p3^ = proc_point
                      then
                        begin {have a parameter of subject procedure}
                          pcount := pcount + 1 ;
                          psave[pcount] := p1 ;
                          if fwdflag = nopar
                            then
                              begin
                                fwdflag := par ;
                                fwdsave := lastgood
                              end
                        end
                      else
                        if fwdflag = none
                          then
                            begin {first parameter of int. proc}
                              fwdflag := nopar ;
                              fwdlast := p1 ;
                              fwdnext := lastgood
                            end
                  end
            end
          else
            if (p1^.idgroup in [procdef, funcdef]) and
               (fwdflag = none) and (p1^.lexlev = lex)
              then
                begin {intermediate procedure}
                  fwdflag := nopar ;
                  fwdlast := p1 ;
                  fwdnext := lastgood
                end ;
        lastgood := p1 ;
        p1 := p1^.nextptr
      until false ;
      p4 := proc_point + align(sizeof(symhead)) ;
      d.tk := align(p4 + longhex(sizeof(proc_head))) ;
      while pcount <> 0 do
        begin {compress parameters}
          p1 := psave[pcount] ;
          pcount := pcount - 1 ;
          s.tk := p1 + align(sizeof(symhead)) ;
          d.tk^ := s.tk^ ; {parameter status}
          d.tk := d.tk + 1 ;
          s.tk := align(s.tk + 1) + 4 ;
          s.tk := get_next(s.tk, true) ;
          d.tk^ := s.tk^ ; {actual type}
          case d.tk^ of
            arrayvar, recordvar, devicevar :
              begin
                d.tk := align(d.tk + 1) ;
                s.tk := align(s.tk + 1) ;
                d.hx^ := s.hx^ ;
                d.lx := d.lx + 2
              end ;
            stringvar, setvar :
              begin
                d.tk := d.tk + 1 ;
                s.tk := s.tk + 1 ;
                d.ch^ := s.ch^ ;
                d.tk := d.tk + 1
              end ;
            subbool .. sublint :
              begin
                d.ch^ := d.ch^ - sub_offset ;
                d.tk := d.tk + 1
              end
            else
              d.tk := d.tk + 1
          end
        end ; {while}
      d.tk^ := termit ;
      if p4^.comp_status in [proc_in_comp, proc_forward]
        then
          p4^.comp_status := proc_normal
        else
          if p4^.comp_status = proc_exc_in
            then
              p4^.comp_status := proc_except ;
      if fwdflag = none
        then
          begin
            next_sym := align(d.tk + 1) ;
            last_sym := proc_point
          end
        else
          begin {forward}
            next_sym := fwdnext ;
            last_sym := fwdlast ;
            if fwdflag = par
              then
                fwdsave^.nextptr := proc_point
          end ;
      if lastpack^.token <> semicolon
        then
          semilook (e_semi) ;
a_pdone :
      alloc := oldalloc ;
      lex := pred(lex) ;
      scan
    end ; {proc_decl}
    
modend.
