module simple {$v3,0 simple expression syntax} ;
{
  5/17/89 : initial conversion to level 3
}
{$I/r0/token}
{$I/r0/code}
{$I/r0/error}
{$I/r0/varib}
{$I/r0/codeproc}

  procedure scan ; external ;
  function term (var terror : error_type ; var lp : labpack) : ^packet ; external ;
  function get_internal : hex ; external ;
  function maycon (pac : ^packet) : boolean ; external ;
  procedure uncon (p : ^packet) ; external ;
  procedure push (p : ^packet) ; external ;
  procedure pull (p : ^packet) ; external ;
  procedure compat (lpac, rpac : ^packet ; var cerror : error_type ;
                    var reverse : boolean) ; external ;
  procedure opdot (pac : ^packet) ; external ;
  function revpost (post : byte) : byte ; external ;
  procedure out_false (level : byte) ; external ;
  procedure out_true (level : byte) ; external ;
  procedure new_false (lev : byte ; num : hex) ; external ;
  procedure new_true (lev : byte ; num : hex) ; external ;
  procedure make_boolean (var lp : labpack) ; external ;
  procedure out_branch (post : byte ; pname : hex) ; external ;
  
  procedure icheck (p : ^packet) ; entry ;
    var
      temp : hex register ;
    begin
      if subrange_opt and (p^.token = integvar)
        then
          begin
            temp := get_internal ;
            opcode (c_xbxx) ;
            post1 (p_bvc + p_rel) ;
            codet_word (temp) ;
            {bvc lbxxx}
            hand (int, $f9) ;
            opcode (c_equ) ;
            post1 (p_imm + p_eqlp) ;
            codet_word (temp) ;
            {lbxxx equ *}
            purge (temp)
          end
    end ;
    
  function simple (var serror : error_type ; var lp : labpack) : ^packet ; entry ;
    var
      eop : token_type register ;
      lpac, rpac, tpac : ^packet register ;
      reverse, orit : boolean ;
      i : integer ;
      pname : hex ;
      two : boolean ;
    begin
      serror := undef ;
      level := level + 1 ;
      repeat
        eop := undef ;
        if lastpack^.token in [plus, minus]
          then
            begin
              eop := lastpack^.token ;
              scan
            end ;
        lpac := term (serror, lp) ;
        if serror <> undef
          then
            exit ;
        if eop <> undef
          then
            begin {leading sign}
              lp.post := p_bnd ;
              if not (lpac^.token in [integvar, lintvar, realvar])
                then
                  begin
                    serror := e_itoo ;
                    exit
                  end ;
              if eop = minus
                then
                  if lpac^.conflag
                    then
                      case lpac^.token of
                        integvar : lpac^.pvc_integer :=
                                   0 - lpac^.pvc_integer ;
                        lintvar : lpac^.pvc_longinteger :=
                                   0 - lpac^.pvc_longinteger ;
                        realvar : 
                          if lpac^.pvc_longhex <> 0
                            then
                              lpac^.pvc_hex := lpac^.pvc_hex eor $8000
                      end
                    else
                      case lpac^.token of
                        integvar : eminln (105) ;
                        lintvar : hand (oper, $11) ;
                        realvar : hand(oper, $26)
                      end
            end ; {eop <> undef}
{sex6}  repeat
          eop := lastpack^.token ;
          orit := false ;
          if not (eop in [plus, minus, or_, eor_])
            then
              begin
                simple := lpac ;
                exit (2)
              end ;
          if (lpac^.token = boolvar) and (eop = or_)
            then
              begin
                orit := true ;
                if lpac^.conflag
                  then
                    begin
                      uncon (lpac) ;
                      lp.post := p_bb
                    end ;
                pname := 0 ;
                for i := true_depth downto 1 do
                  if true_tab[i].lev = level
                    then
                      begin
                        pname := true_tab[i].num ;
                        for i := i + 1 to true_depth do
                          true_tab[i].lev := level ;
                        exit
                      end ;
                if pname = 0
                  then
                    begin
                      pname := get_internal ;
                      new_true (level, pname)
                    end ;
                out_branch (revpost(lp.post), pname) ;
                lp.post := p_bnd ;
                out_false (level)
              end
            else
              begin
                if (eop = eor_) and (lpac^.token = boolvar)
                  then
                    begin
                      if lpac^.conflag
                        then
                          begin
                            uncon (lpac) ;
                            lp.post := p_bb
                          end ;
                      make_boolean (lp)
                    end ;
                if lpac^.conflag
                  then
                    if maycon (lpac)
                      then
                        push (lpac)
                      else
                  else
                    push (lpac) ;
                reverse := false ;
              end ;
          scan ;
          lp.post := p_bnd ;
          rpac := term (serror, lp) ;
          if serror <> undef
            then
              exit (2) ;
          if orit
            then
              begin
                if rpac^.token <> boolvar
                  then
                    begin
                      serror := e_tc ;
                      exit (2)
                    end ;
                if rpac^.conflag
                  then
                    begin
                      uncon (rpac) ;
                      lp.post := p_bb
                    end ;
                lpac := rpac
              end
            else
              begin
                if (eop = eor_) and (rpac^.token = boolvar)
                  then
                    begin
                      if rpac^.conflag
                        then
                          begin
                            uncon (rpac) ;
                            lp.post := p_bb
                          end ;
                      make_boolean (lp)
                    end ;
                if maycon (rpac)
                  then ;
                case eop of
                  or_, eor_ :
                    begin
                      if lpac^.token <> rpac^.token
                        then
                          begin
                            compat (lpac, rpac, serror, reverse) ;
                            if serror <> undef
                              then
                                exit (2)
                          end ;
                      if lpac^.token > lintvar
                        then
                          begin
                            serror := e_itoo ;
                            exit (2)
                          end ;
                      two := lpac^.token in [integvar, hexvar] ;
                      if lpac^.conflag and rpac^.conflag
                        then
                          if eop = or_
                            then
                              begin
                                lpac^.pvc_char := lpac^.pvc_char or
                                                  rpac^.pvc_char ;
                                lpac^.pvc_longhex := lpac^.pvc_longhex or
                                                     rpac^.pvc_longhex
                              end
                            else
                              begin
                                lpac^.pvc_char := lpac^.pvc_char eor
                                                  rpac^.pvc_char ;
                                lpac^.pvc_longhex := lpac^.pvc_longhex eor
                                                     rpac^.pvc_longhex
                              end
                        else {both not constants}
                          if lpac^.conflag or rpac^.conflag
                            then
                              begin {one of them is constant}
                                if lpac^.conflag
                                  then
                                    begin
                                      tpac := lpac ;
                                      lpac^.conflag := false
                                    end
                                  else
                                    begin
                                      pull (lpac) ;
                                      tpac := rpac
                                    end ;
                                if two and (tpac^.pvc_hex > $ff)
                                  then
                                    begin
                                      if eop = or_
                                        then
                                          opcode (c_ora)
                                        else
                                          opcode (c_eora) ;
                                      post2t (p_imm, byte(tpac^.pvc_hex >> 8))
                                    end ;
                                if two
                                  then
                                    tpac^.pvc_char := byte(tpac^.pvc_hex) ;
                                if tpac^.pvc_char <> 0
                                  then
                                    begin
                                      if eop = or_
                                        then
                                          opcode (c_orb)
                                        else
                                          opcode (c_eorb) ;
                                      post2t (p_imm, tpac^.pvc_char)
                                    end
                              end
                            else
                              begin {both expressions}
                                if lpac^.token in [lhexvar, lintvar]
                                  then
                                    if eop = or_
                                      then
                                        hand (oper, $47)
                                      else
                                        hand (oper, $48)
                                else 
                                  begin
                                    if two
                                      then
                                        begin
                                          if eop = or_
                                            then
                                              opcode (c_ora)
                                            else
                                              opcode (c_eora) ;
                                          post1t (p_idx + p_ixru + p_ixp) ;
                                          {ora 0,u+ or eora 0,u+}
                                        end ;
                                    if eop = or_
                                      then
                                        opcode (c_orb)
                                      else
                                        opcode (c_eorb) ;
                                    post1t (p_idx + p_ixru + p_ixp) ;
                                    {orb 0,u+ or eorb 0,u+}
                                  end
                              end
                    end ;
                  plus, minus :
                    begin
                      if lpac^.token <> rpac^.token
                        then
                          begin
                            compat (lpac, rpac, serror, reverse) ;
                            if serror <> undef
                              then
                                exit (2)
                          end ;
                      if not (lpac^.token in [charvar, integvar .. realvar, setvar])
                        then
                          begin
                            serror := e_itoo ;
                            exit (2)
                          end ;
                      two := lpac^.token in [integvar, hexvar] ;
                      if eop = plus
                        then
                          if lpac^.conflag and rpac^.conflag
                            then {const + const}
                              case lpac^.token of
                                charvar : 
                                  lpac^.pvc_char := lpac^.pvc_char + 
                                                    rpac^.pvc_char ;
                                integvar, hexvar :
                                  lpac^.pvc_hex := lpac^.pvc_hex +
                                                   rpac^.pvc_hex
                              end
                            else
                              if lpac^.conflag or rpac^.conflag
                                then
                                  begin {one of 'em is constant}
                                    if lpac^.conflag
                                      then
                                        tpac := lpac
                                      else
                                        begin
                                          pull (lpac) ;
                                          tpac := rpac
                                        end ;
                                    if two
                                      then
                                        opcode (c_addd)
                                      else
                                        opcode (c_addb) ;
                                    opdot (tpac) ; {addd #con or addb #con}
                                    lpac^.conflag := false ;
                                    icheck (lpac)
                                  end
                                else {expr + expr}
                                  case lpac^.token of
                                    charvar, integvar .. hexvar :
                                      begin
                                        if two
                                          then
                                            begin
                                              opcode (c_addd) ;
                                              post1t (p_idx + p_ixru + p_ixpp)
                                              {addd 0,u++}
                                            end
                                          else
                                            begin
                                              opcode (c_addb) ;
                                              post1t (p_idx + p_ixru + p_ixp)
                                              {addb 0,u+}
                                            end ;
                                        icheck (lpac)
                                      end ;
                                    realvar : hand (oper, $20) ;
                                    lintvar : hand (oper, 5) ;
                                    lhexvar : hand (oper, $41) ;
                                    setvar : hand (oper, $30)
                                  end
                        else {is minus}
                          if lpac^.conflag and rpac^.conflag
                            then {const - const}
                              case lpac^.token of
                                charvar : 
                                  lpac^.pvc_char := lpac^.pvc_char - 
                                                    rpac^.pvc_char ;
                                integvar, hexvar :
                                  lpac^.pvc_hex := lpac^.pvc_hex -
                                                   rpac^.pvc_hex
                              end
                            else
                              if lpac^.conflag or rpac^.conflag
                                then
                                  begin {one of 'em is constant}
                                    if lpac^.conflag
                                      then
                                        tpac := lpac
                                      else
                                        begin
                                          pull (lpac) ;
                                          tpac := rpac
                                        end ;
                                    if lpac^.conflag
                                      then
                                        begin
                                          if two
                                            then
                                              begin
                                                eminln (106) ; {negd}
                                                lpac^.pvc_hex := lpac^.pvc_hex + 1 ;
                                                opcode (c_addd)
                                              end
                                            else
                                              begin
                                                opcodet (c_negb) ; {negb}
                                                lpac^.pvc_char := lpac^.pvc_char ;
                                                opcode (c_addb)
                                              end ;
                                          lpac^.conflag := false ;
                                          tpac := lpac
                                        end
                                      else
                                        begin
                                          if two
                                            then
                                              opcode (c_subd)
                                            else
                                              opcode (c_subb) ;
                                          tpac := rpac
                                        end ;
                                    opdot (tpac) ;
                                    icheck (tpac)
                                  end
                                else {exp - exp}
                                  case lpac^.token of
                                    charvar, integvar .. hexvar :
                                      begin
                                        if two
                                          then
                                            begin
                                              eminln (105) ;
                                              opcode (c_addd) ;
                                              post1t (p_idx + p_ixru + p_ixpp)
                                              {addd 0,u++}
                                            end
                                          else
                                            begin
                                              opcodet (c_negb) ;
                                              opcode (c_addb) ;
                                              post1t (p_idx + p_ixru + p_ixp)
                                              {addb 0,u+}
                                            end ;
                                        icheck (lpac)
                                      end ;
                                    lhexvar .. realvar : 
                                      begin
                                        if reverse
                                          then
                                            hand (int, 9) ;
                                        case lpac^.token of
                                          lintvar : hand (oper, 6) ;
                                          lhexvar : hand (oper, $42) ;
                                          realvar : hand (oper, $21)
                                        end
                                      end ;
                                    setvar : hand (oper, $31)
                                  end
                    end {plus, minus}
                end {case eop of}
              end
        until false
      until true ;
      level := level - 1
    end ;
    
modend.
