module term {$v3,0 term syntax} ;
{
  5/17/89 : initial conversion to level 3
}
{$I/r0/token}
{$I/r0/code}
{$I/r0/error}
{$I/r0/varib}
{$I/r0/codeproc}

  procedure scan ; external ;
  function factor (var terror : error_type ; var lp : labpack) : ^packet ; external ;
  function get_internal : hex ; external ;
  function maycon (pac : ^packet) : boolean ; external ;
  procedure uncon (p : ^packet) ; external ;
  procedure push (p : ^packet) ; external ;
  procedure pull (p : ^packet) ; external ;
  procedure compat (lpac, rpac : ^packet ; var cerror : error_type ;
                    var reverse : boolean) ; external ;
  procedure opdot (pac : ^packet) ; external ;
  procedure icheck (p : ^packet) ; external ;
  function revpost (post : byte) : byte ; external ;
  procedure out_false (level : byte) ; external ;
  procedure out_true (level : byte) ; external ;
  procedure new_false (lev : byte ; num : hex) ; external ;
  procedure new_true (lev : byte ; num : hex) ; external ;
  procedure out_branch (post :byte ; pname : hex) ; external ;
  
  function term (var terror : error_type ; var lp : labpack) : ^packet ; entry ;
    var
      eop : token_type register ;
      lpac, rpac, tpac : ^packet register ;
      reverse, andit, two : boolean ;
      top : byte ;
      cnt : hex ;
      pname : hex ;
      i : integer ;
      opsel : byte ;
    begin
      terror := undef ;
      level := level + 1 ;
      lpac := factor(terror, lp) ;
      if terror = undef
        then
          repeat
            eop := lastpack^.token ;
            andit := false ;
            if not (eop in [times, divide, power, div_, mod_,
                            and_, shift_left, shift_right])
              then
                begin {not a term operator}
                  term := lpac ;
                  exit
                end ;
{
  have a term operator
}
            if (lpac^.token = boolvar) and (eop = and_)
              then
                begin
                  andit := true ;
                  if lpac^.conflag
                    then
                      begin
                        uncon (lpac) ;
                        lp.post := p_bb
                      end ;
                  pname := 0 ;
                  for i := false_depth downto 1 do
                    if false_tab[i].lev = level
                      then
                        begin
                          pname := false_tab[i].num ;
                          for i := i + 1 to false_depth do
                            false_tab[i].lev := level ;
                          exit
                        end ;
                  if pname = 0
                    then
                      begin
                        pname := get_internal ;
                        new_false (level, pname)
                      end ;
                  out_branch (lp.post, pname) ;
                  lp.post := p_bnd ;
                  out_true (level)
                end
              else
                begin
                  if eop in [divide, power, div_, mod_]
                    then
                      uncon (lpac) ;
                  if lpac^.conflag
                    then
                      if maycon (lpac)
                        then
                          push (lpac)
                        else
                    else
                      push (lpac) ;
                  reverse := false
                end ;
            scan ;
            lp.post := p_bnd ;
            rpac := factor (terror, lp) ;
            if terror <> undef
              then
                exit ;
            if andit
              then
                begin
                  if rpac^.token <> boolvar
                    then
                      begin
                        terror := e_tc ;
                        exit
                      end ;
                  if rpac^.conflag
                    then
                      begin
                        uncon (rpac) ;
                        lp.post := p_bb
                      end ;
                  lpac := rpac
                end
              else
                begin
                  if maycon (rpac)
                    then ;
                  case eop of
                    and_ :
                      begin
                        if lpac^.token <> rpac^.token
                          then
                            begin
                              compat (lpac, rpac, terror, reverse) ;
                              if terror <> undef
                                then
                                  exit
                            end ;
                        if lpac^.token > lintvar
                          then
                            begin
                              terror := e_itoo ;
                              exit
                            end ;
                        two := lpac^.token in [integvar, hexvar] ;
                        if lpac^.conflag and rpac^.conflag
                          then
                            begin {const and const}
                              lpac^.pvc_char := lpac^.pvc_char and
                                                rpac^.pvc_char ;
                              lpac^.pvc_longhex := lpac^.pvc_longhex and
                                                   rpac^.pvc_longhex
                            end
                          else
                            if lpac^.conflag or rpac^.conflag
                              then
                                begin {one side is constant}
                                  if lpac^.conflag
                                    then
                                      tpac := lpac
                                    else
                                      begin
                                        pull (lpac) ;
                                        tpac := rpac
                                      end ;
                                  lpac^.conflag := false ;
                                  if two and (tpac^.pvc_hex and $ff00 <> $ff00)
                                    then
                                      begin
                                        opcode (c_anda) ;
                                        post2t (p_imm, byte(tpac^.pvc_hex >> 8)) ;
                                        {anda #xx}
                                      end ;
                                  if two
                                    then
                                      tpac^.pvc_char := byte(tpac^.pvc_hex) ;
                                  if tpac^.pvc_char <> $ff
                                    then
                                      begin
                                        opcode (c_andb) ;
                                        post2t (p_imm, tpac^.pvc_char)
                                        {andb #xx}
                                      end
                                end
                              else
                                begin {exp and exp}
                                  if lpac^.token in [lintvar, lhexvar]
                                    then
                                      hand (oper, $46)
                                    else
                                      begin
                                        if two
                                          then
                                            begin
                                              opcode (c_anda) ;
                                              post1t (p_idx + p_ixru + p_ixp)
                                              {anda 0,u+}
                                            end ;
                                        opcode (c_andb) ;
                                        post1t (p_idx + p_ixru + p_ixp)
                                        {andb 0,u+}
                                      end
                                end
                      end ; {and_}
                    div_, mod_ :
                      begin
                        if lpac^.token <> rpac^.token
                          then
                            begin
                              compat (lpac, rpac, terror, reverse) ;
                              if terror <> undef
                                then
                                  exit
                            end ;
                        if not (lpac^.token in [charvar .. lintvar])
                          then
                            begin
                              terror := e_itoo ;
                              exit
                            end ;
                        uncon (rpac) ;
                        case lpac^.token of
                          charvar : opsel := $16 ;
                          integvar : opsel := 3 ;
                          hexvar : opsel := $13 ;
                          lhexvar : opsel := $52 ;
                          lintvar : opsel := 8
                        end ;
                        if eop = mod_
                          then
                            opsel := opsel + 1 ;
                        hand (oper, opsel)
                      end ; {div_, mod_}
                    power, divide :
                      begin
                        case rpac^.token of
                          realvar : ;
                          lintvar : hand (int, $42) ;
                          integvar :
                            begin
                              uncon (rpac) ;
                              hand (int, 6)
                            end
                          else
                            begin
                              terror := e_itoo ;
                              exit
                            end
                        end ;
                        rpac^.token := realvar ;
                        if lpac^.token <> realvar
                          then
                            begin
                              compat (lpac, rpac, terror, reverse) ;
                              if terror <> undef
                                then
                                  exit
                            end ;
                        if eop = divide
                          then
                            hand (oper, $23)
                          else
                            hand (oper, $24)
                      end ; {divide, power}
                    shift_left, shift_right :
                      begin
                        if lpac^.token <> rpac^.token
                          then
                            begin
                              compat (lpac, rpac, terror, reverse) ;
                              if terror <> undef
                                then
                                  exit
                            end ;
                        if not (lpac^.token in [charvar .. lintvar])
                          then
                            begin
                              terror := e_itoo ;
                              exit
                            end ;
                        two := lpac^.token in [integvar, hexvar] ;
                        if lpac^.conflag and rpac^.conflag
                          then {both constants}
                            case lpac^.token of
                              charvar :
                                if eop = shift_left
                                  then
                                    lpac^.pvc_char := lpac^.pvc_char <<
                                                      rpac^.pvc_char
                                  else
                                    lpac^.pvc_char := lpac^.pvc_char >>
                                                      rpac^.pvc_char ;
                              integvar, hexvar :
                                if eop = shift_left
                                  then
                                    lpac^.pvc_hex := lpac^.pvc_hex <<
                                                     rpac^.pvc_hex
                                  else
                                    lpac^.pvc_hex := lpac^.pvc_hex >>
                                                     rpac^.pvc_hex
                            end
                          else
                            if rpac^.conflag
                              then
                                begin {expr <<>> const}
                                  case rpac^.token of
                                    charvar : 
                                      cnt := hex(rpac^.pvc_char) ;
                                    integvar, hexvar :
                                      cnt := hex(rpac^.pvc_hex)
                                  end ;
                                  if (cnt = 8) and two
                                    then
                                      begin
                                        opcode (c_pulu) ;
                                        post1t (p_ipd) ;
                                        {pulu d}
                                        if eop = shift_right
                                          then
                                            begin {divide by 2}
                                              opcode (c_tfr) ;
                                              post1t (p_itab) ;
                                              {tfr a,b}
                                              opcodet (c_clra)
                                            end
                                          else
                                            begin
                                              opcode (c_tfr) ;
                                              post1t (p_itba) ;
                                              {tfr b,a}
                                              opcodet (c_clrb)
                                            end
                                      end
                                  else if (cnt <= 3) or ((cnt <= 3) and not two)
                                    then
                                      begin {inline}
                                        if two
                                          then
                                            begin
                                              opcode (c_pulu) ;
                                              post1t (p_ipd) ;
                                              {pulu d}
                                              while cnt <> 0 do
                                                begin
                                                  if eop = shift_left
                                                    then
                                                      eminln (104)
                                                    else
                                                      eminln (107) ;
                                                  cnt := cnt - 1
                                                end
                                            end
                                          else
                                            begin
                                              opcode (c_pulu) ;
                                              post1t (p_ipb) ;
                                              while cnt <> 0 do
                                                begin
                                                  if eop = shift_left
                                                    then
                                                      opcodet (c_aslb)
                                                    else
                                                      opcodet (c_lsrb) ;
                                                  cnt := cnt - 1
                                                end
                                            end
                                      end
                                    else
                                      begin {routines}
                                        if two
                                          then
                                            begin
                                              opcode (c_ldd) ;
                                              opdot (rpac) ; {ldd #count}
                                              if eop = shift_left
                                                then
                                                  hand (oper, $38)
                                                else
                                                  hand (oper, $39)
                                            end
                                          else
                                            begin
                                              opcode (c_ldb) ;
                                              opdot (rpac) ;
                                              if eop = shift_left
                                                then
                                                  hand (oper, $36)
                                                else
                                                  hand (oper, $37)
                                            end
                                      end
                                end
                              else
                                begin {const <<>> exp or exp <<>> exp}
                                  if lpac^.conflag
                                    then
                                      begin
                                        lpac^.conflag := false ;
                                        if two
                                          then
                                            begin
                                              opcode (c_ldx) ;
                                              post1 (p_imm) ;
                                              codet_word (lpac^.pvc_hex) ;
                                              {ldx #count}
                                              opcode (c_pshu) ;
                                              post1t (p_ipx)
                                              {pshu x}
                                            end
                                          else
                                            begin
                                              ldaim (lpac^.pvc_char) ;
                                              {lda #count}
                                              opcode (c_pshu) ;
                                              post1t (p_ipa)
                                              {pshu a}
                                            end
                                      end ;
                                  if lpac^.token in [lhexvar, lintvar]
                                    then
                                    if eop = shift_left
                                        then
                                          hand (oper, $44)
                                        else
                                          hand (oper, $45)
                                  else if two
                                    then
                                      if eop = shift_left
                                        then
                                          hand (oper, $38)
                                        else
                                          hand (oper, $39)
                                    else
                                      if eop = shift_left
                                        then
                                          hand (oper, $36)
                                        else
                                          hand (oper, $37)
                                end
                      end ; {shift_left, shift_right}
                    times :
                      begin
                        if lpac^.token <> rpac^.token
                          then
                            begin
                              compat (lpac, rpac, terror, reverse) ;
                              if terror <> undef
                                then
                                  exit
                            end ;
                        if not (lpac^.token in [charvar .. realvar, setvar])
                          then
                            begin
                              terror := e_itoo ;
                              exit
                            end ;
                        two := lpac^.token in [integvar, hexvar] ;
                        if lpac^.conflag and rpac^.conflag
                          then {both constants}
                            case lpac^.token of
                              charvar :
                                lpac^.pvc_char := lpac^.pvc_char *
                                                  rpac^.pvc_char ;
                              integvar :
                                lpac^.pvc_integer := lpac^.pvc_integer *
                                                     rpac^.pvc_integer ;
                              hexvar :
                                lpac^.pvc_hex := lpac^.pvc_hex *
                                                 rpac^.pvc_hex
                            end
                          else
                            if lpac^.conflag or rpac^.conflag
                              then
                                begin {one of 'em is constant, and does not
                                       require a subroutine}
                                  if lpac^.conflag
                                    then
                                      begin
                                        if two
                                          then
                                            begin
                                              opcode (c_pshu) ;
                                              post1t (p_ipd) ;
                                              {pshu d}
                                            end ;
                                        tpac := lpac ;
                                        lpac^.conflag := false
                                      end
                                    else
                                      begin
                                        if not two
                                          then
                                            begin
                                              opcode (c_pulu) ;
                                              post1t (p_ipb) ;
                                              {pulu b}
                                            end ;
                                        tpac := rpac ;
                                      end ;
                                  if two
                                    then
                                      lddim (tpac^.pvc_hex)
                                    else
                                      ldaim (tpac^.pvc_char) ;
                                  {lda #const or ldd #const}
                                  case lpac^.token of
                                    charvar : opcodet (c_mul) ;
                                    integvar : hand (oper, 2) ;
                                    hexvar : hand (oper, $12)
                                  end
                                end
                              else
                                begin {no usable constants}
                                  case lpac^.token of
                                    charvar :
                                      begin
                                        opcode (c_pulu) ;
                                        post1t (p_ipa) ;
                                        {pulu a}
                                        opcodet (c_mul)
                                        {mul}
                                      end ;
                                    integvar : hand (oper, 2) ;
                                    hexvar : hand (oper, $12) ;
                                    lhexvar : hand (oper, $51) ;
                                    lintvar : hand (oper, 7) ;
                                    realvar : hand (oper, $22) ;
                                    setvar : hand (oper, $32)
                                  end
                                end
                      end {times}
                  end {case eof}
                end
          until false ;
      level := level - 1
    end ; {term}
    
modend.
