{$l-}
  const
    table_max = 1600 ; { global symbol table size }
    mod_end = 200 ; { in_mod table size }
    plus_rel = #1 ; { psct esd entry number }
    comax = $C00 ; {command buffer size}
    holemax = 20 ; {hole buffer size}
 
  type
    section = (undef,abso,relo,dsect,vsect) ;
 
    sym_entry =  record
                   name : string [8] ;
                   status : section ;
                   modnum : integer ;
                   value : hex ;
                 end ;

    sym_type = array [1..table_max] of sym_entry ;
 
    mod_type = record
                 coff, doff, voff : hex ;
                 csize, dsize, vsize : hex ;
                 mcur : array [relo..vsect] of boolean ;
                 mplus, mmask : array [relo..vsect] of hex ;
                 vers : byte ;
                 rev : byte ;
                 name : string [8] ;
                 desc : string[40]
               end ;
 
    esd_type = array [0 .. 255] of hex ;
    
    wordbytes = record
                  case boolean of
                    false : (b1, b2 : byte) ;
                    true : (l : hex)
                end ;
                
    com_string = string ;
  
    blkbuffer = array [1..4096] of byte ;

    holetype = array [1 .. holemax] of record
                                         hstart, hend : hex
                                       end ;
                                            
  var
    done,ref_satisfied,endp_set,pass1,comon,fopt         : boolean ;
    badlink,exec_set,dsect_set,endexc,comredir           : boolean ;
    rel_abs, initon                                      : boolean ;
    rec_lth, check, stemp, initvalue                     : byte ;
    cbl,max_symbol,old_max_sym,table_end,pline,max_pline : integer ;
    holecnt, max_module, curr_mod_num, mapwidth : integer ;
    cfadr : ^byte ;
    symbol : ^sym_type ;
    hex_value, lowest, rel_offset, rec_offset, highest : hex ;
    start_exec : wordbytes ;
    sect : section ;
    membase, memsize : longhex ;
    curon, endset : array [relo..vsect] of boolean ;
    strsect, endsect, loc, curplus, curmask,
    oldloc, sectsize : array [relo..vsect] of hex ;
    ifname, oname, mname, cname, com_field, indir : string [80] ;
    com_buf, old_com, comnd : string ;
    inrec, out_buf,fill_record : string [251] ;
    combase, comstore : ^com_string ;
    in_mod : array [0 .. mod_end] of mod_type ;
    esd_tab : esd_type ;
    esd_abs : array [0 .. 255] of boolean ;
    mod_loaded : set of 1 .. mod_end ;
    iblkbuf : ^blkbuffer ;
    iblkmax, iblkcur : ^byte ;
    holetab : holetype ;
{$l+}
