{$l-}
{
  7/23/89 : sym_format changed to allow addressing of one past
  end of symbol table.
}
const
  Edit      = 3 ;
  max_match = 35 ;
  max_ref   = 125 ;
  max_sym   = 1800 ;
  first_sym = 1 ;
  max_cl    = 5 ;

type
  registers = (no_reg,d,x,y,u,s,pc,a,b,ccr,dpr) ;
  
  s_type = (sym_err, forward, encountered, absolute, relative,
            xref, xdef, equ, dsect, vsect, setable, macro, multdef) ;

  oper_group = (err_oper, inherent, extended, immediate, indexed,
                relad, reg_2, reg_list, ext_imm_ind, ext_ind, direct,
                psuedo) ;
              
  sect_type = (abs, prg, dat, varb) ;
 
  sym_describe = record
                   sym_nam : string [8] ;
                   esd_num : byte ;
                   sym_addr : longhex ;
                   sym_type : set of s_type
                 end ;
 
  sym_format = array [1..max_sym + 1] of sym_describe ;
 
  ref_type = array [0 .. max_ref] of
               record
                 ref_id : integer ;
                 long_reloc : boolean ;
                 ref_addr : hex
               end;
 
  string80 = string[80] ;

  macro_stack = record
                  current_line : ^string80 ;
                  lines_left : byte
                end ;

var
  warn_opt, include, fopt, enabled, ex_set, hopt : boolean ;
  end_pass, pass_2, disaster, list, list_on, line_err, topt : boolean ;
  comment, list_opt, out_opt, won, known : boolean ;
  macro_def, line_num, macro_expansion, macro_done : boolean ;
  stemp, version, revision : byte ;
  err_cnt, max_pline, max_char, cl_i, pline : integer ;
  reloc_idx, size, xrel : integer ;
  gen_label, if_depth : integer ;
  curr_sym, line_cnt, incl_line, left_start, tab_sym : integer ;
  sym_end, list_cnt, page_cnt, symidx, altidx : integer ;
  opcode_out, hex_value : hex ;
  macro_line : ^string80 ;
  current_macro : ^macro_stack ;
  branch_cluge : boolean ;
  sect, oldsec : sect_type ;
  sym_tab : ^sym_format ;
  macro_size, macro_end : longhex ;
  addr_mode : oper_group ;
  ret_type : s_type ;
  after_post : (no_off, off_8, off_16) ;
  record_start, ex_offset, oldloc : hex ;
  loc : array [sect_type] of hex ;
  code_line : array [0 .. max_cl] of byte ;
  if_stack : array [0 .. 30] of boolean ;
  oplook, alabel, modname : string[8] ;
  operation : string[10] ;
  blank : string[20] ; 
  time : string [30] ;
  leftover, title, operand, listopnd, rex_string, moddesc : string [120];
  ofname, lfname, ifname, nfname, com_field, field : string [80] ;
  macro_parameters, in_line : string[120] ;
  out_buf,  prnt_line : string[251] ;
  refs : ref_type ;
 
const
  res_match = external array [0 .. max_match] of s_type ;
  l_match = external array [0 .. max_match] of s_type ;
  r_match = external array [0 .. max_match] of s_type ;
  s_match = external array [0 .. max_match] of char ;
{$l+}
