module def_heap {$3,0 default heap handler} ;
  const
    error_check = true ; {set to false to disable overflow checking}
{$I/dd/defs/globals}
{$I/dd/defs/mtk_type}

  procedure new_long (var pointer : hex ; global : ^global_frame ;
                      size, stack : hex) ; entry ;
    var
      tcbpt : ^tcb ;
      regpt : ^registers ;
    begin
      with global^ do
        begin
          if r_eflg and r_task <> 0
            then
              begin
                tcbpt := r_tcb1 ;
                regpt := tcbpt^.stack_ptr ;
                if regpt^.u_stack < r_hplm
                  then
                    r_hplm := regpt^.u_stack
              end
          else if stack < r_hplm
            then
              r_hplm := stack ;
          pointer := r_hppt ;
          r_hppt := r_hppt + size ;
{$cne error_check}
          if r_hppt > r_hplm
            then
              halt (19)
{$cend}
        end
    end ;
                
  procedure mark_long (var pointer : hex ; global : ^global_frame) ; entry ;
    begin
      pointer := global^.r_hppt
    end ;
  
  procedure rel_long (var pointer : hex ; global : ^global_frame) ; entry ;
    begin
      global^.r_hppt := pointer
    end ;
  
  procedure disp_long (var pointer : hex ; global : ^global_frame ;
                       size, stack : hex) ; entry ;
    begin
      pointer := nil
    end ;

  function mema_long (global : ^global_frame ; stack : hex) : hex ; entry ;
    var
      tcbpt : ^tcb ;
      regpt : ^registers ;
    begin
      with global^ do
        begin
          if r_eflg and r_task <> 0
            then
              begin
                tcbpt := r_tcb1 ;
                regpt := tcbpt^.stack_ptr ;
                if regpt^.u_stack < r_hplm
                  then
                    r_hplm := regpt^.u_stack
              end
          else if stack < r_hplm
            then
              r_hplm := stack ;
          mema_long := r_hplm - r_hppt
        end
    end ;
                
modend.     
