*
* 7/22/89 : andcc and orcc added.
*
* opcodes
*
 abs 0
c_pass ds.b 1 0
c_inline ds.b 1 0
c_data ds.b 1 0
c_bug ds.b 1 0
c_line ds.b 1 0
c_purge ds.b 1 0
c_equ ds.b 1 1
c_abx ds.b 1 0
c_addb ds.b 1 1
c_addd ds.b 1 1
c_anda ds.b 1 1
c_andb ds.b 1 1
c_andcc ds.b 1 1
c_asla ds.b 1 0
c_aslb ds.b 1 0
c_asra ds.b 1 0
c_asrb ds.b 1 0
c_clra ds.b 1 0
c_clrb ds.b 1 0
c_clr ds.b 1 1
c_cmpb ds.b 1 1
c_cmpd ds.b 1 1
c_coma ds.b 1 0
c_comb ds.b 1 0
c_deca ds.b 1 0
c_decb ds.b 1 0
c_dec ds.b 1 1
c_eora ds.b 1 1
c_eorb ds.b 1 1
c_inca ds.b 1 0
c_incb ds.b 1 0
c_inc ds.b 1 1
c_irq ds.b 1 1
c_jsr ds.b 1 1
c_lda ds.b 1 1
c_ldb ds.b 1 1
c_ldd ds.b 1 1
c_ldx ds.b 1 1
c_leax ds.b 1 1 
c_leau ds.b 1 1
c_lsra ds.b 1 0
c_lsrb ds.b 1 0
c_mul ds.b 1 0
c_negb ds.b 1 0
c_ora ds.b 1 1
c_orb ds.b 1 1
c_orcc ds.b 1 1
c_pshu ds.b 1 1
c_pulu ds.b 1 1 
c_rola ds.b 1 0
c_rolb ds.b 1 0
c_rora ds.b 1 0
c_rorb ds.b 1 0
c_rts ds.b 1 0
c_sex ds.b 1 0
c_stb ds.b 1 1
c_std ds.b 1 1
c_stx ds.b 1 1
c_subb ds.b 1 1
c_subd ds.b 1 1
c_tfr ds.b 1 1
c_tsta ds.b 1 0
c_tstb ds.b 1 0
c_xbxx ds.b 1 1
c_rmb ds.b 1 1
c_zap ds.b 1 0
cd_code ds.b 1 0
cd_data ds.b 1 0
cd_varib ds.b 1 0
cd_end ds.b 1 0
*
* post byte format
*
p_imm equ $00 immediate/equ
p_abs equ $08 absolute
p_idx equ $40 indexed
p_rel equ $80 relative
*
* formats for push/pull
*
 abs 1
p_ipa ds.b 1 a register
p_ipb ds.b 1 b register
p_ipd ds.b 1 d register
p_ipx ds.b 1 x register
p_ipy equ 8 y register
p_ips equ $10 s register
*
* formats for tfr
*
 abs 0
p_itba ds.b 1 b -> a
p_itab ds.b 1 a -> b
p_itdx ds.b 1 d -> x
p_itxd ds.b 1 x -> d
*
* formats for equ
*
 abs 0
p_eqlp ds.b 1 lbxxxx equ *
p_eqnv ds.b 1 not valid
p_eqep ds.b 1 xxxx equ *
p_eqea ds.b 1 xxxx equ $yyyy
*
* immediate/absolute direct page
*
p_dir equ 1 direct page
*
* indexed indirect bit
*
p_idxi equ $20
*
* absolute external flag
*
p_ae equ $01 external if set
*
* indexed registers
*
p_ixrx equ 0 ,x
p_ixry equ 8 ,y
p_ixru equ $10 ,u
p_ixrp equ $18 ,pcr
*
* indexed offset types
*
 abs 0
p_ixfx ds.b 1 fixed offset
p_ixex ds.b 1 external offset
p_ixb ds.b 1 b,r
p_ixd ds.b 1 d,r
p_ixp ds.b 1 0,r+
p_ixpp ds.b 1 0,r++
p_ixm ds.b 1 0,-r
p_ixz ds.b 1 0,r
*
* relative external name flag
*
p_bcex equ $20 external if set
*
* relative long/short flag
*
p_rell equ $10 long if set
*
* conditinal types
*
 abs 0
p_bra ds.b 1
p_bsr ds.b 1
p_bhi ds.b 1
p_bls ds.b 1
p_bcc ds.b 1
p_bhs equ p_bcc
p_bcs ds.b 1
p_blo equ p_bcs
p_bne ds.b 1
p_beq ds.b 1
p_bvc ds.b 1
p_bvs ds.b 1
p_bpl ds.b 1
p_bmi ds.b 1
p_bge ds.b 1
p_blt ds.b 1
p_bgt ds.b 1
p_ble ds.b 1
*
* formats for irq instructions
*
 abs 1
p_save ds.b 1 pshs u,y,x,d
p_ldy ds.b 1 ldy global
p_rest ds.b 1 puls u,y,x,d
p_rti ds.b 1 rti
p_leay ds.b 1 leay 10,u
*
* code generation routines
*
 abs 0
rpass ds.b 1 pass routine
rinline ds.b 1 inline routine
rdata ds.b 1 data routine
rbug ds.b 1 debug routine
rline ds.b 1 line number routine
rpurg ds.b 1 purge routine
requ ds.b 1 equate routine
rzap ds.b 1 zap instruction
rdcode ds.b 1 code directive
rddata ds.b 1 data directive
rdvarib ds.b 1 varib directive
rdend ds.b 1 end directive
rrmb ds.b 1 rmb directive
rirq ds.b 1 irq instructions
grp1 ds.b 1 inherent
grp2 ds.b 1 indexed only (leau,leax)
grp3 ds.b 1 relative (branches)
grp4 ds.b 1 two register (tfr,exg)
grp5 ds.b 1 register list (psh/pul)
grp6 ds.b 1 extended,immediate,and indexed
grp7 ds.b 1 extended and indexed
*
* definition of internal label table
* record {int_type}
*
 abs 0
active ds.b 1 internal slot active if nonzero
define ds.b 1 defined if nonzero
intname ds 1 internal name
ival ds 1 value
intsize equ * size of internal label entry
*
* definition of external label table
* record {ext_type}
*
 abs 0
eact ds.b 1 active slot
edef ds.b 1 defined via equ
eval ds.w 1 value
emod ds.b 1 module
esect ds.b 1 definition section (abs/rel/dat/var)
ename ds.b 10 external name (max 8 char)
esize equ *
*
* error codes
*
 abs 0
t_none ds.b 1 no error
t_cover ds.b 1 code overflow
t_brange ds.b 1 branch out of range
t_intovr ds.b 1 internal label table overflow
t_done ds.b 1 done with file
t_extovr ds.b 1 external label table overflow
t_varovr ds.b 1 varib section overflow
t_dbovr ds.b 1 debugger table overflow
t_pterr ds.b 1 pointer update error
t_vers ds.b 1 wrong version
t_datovr ds.b 1 data section overflow
t_invop ds.b 1 invalid opcode
t_mdef ds.b 1 multiply defined external symbol
*
 code
