Program xlb {$v3,0 xlb} (Input, Output) ;
{
  6/6/89 : initial conversion to level 3
}
  const
    FNF = 216 ;

  Var
    cparm, max, count, col : integer ;
    rcnt, cbyte, clth, hdr : byte ;
    seq : boolean ;
    prefix : string [2] ;
    ifile, ofile : file of byte ;
    ispec, iname : string [32] ;

  function sufadd (fname : string[60] ; suf : string[2]) : string[60] ;
    var
      x : integer ;
    begin
      for x := length(fname) downto 0 do
        if (fname[x] = '/') or (x = 0)
          then
            begin
              if index(substr(fname,x+1,32),'.') = 0
                then
                  sufadd := concat(fname,'.',suf)
                else
                  sufadd := fname ;
              exit
            end
    end ;
    
  Begin { lib }
    {$I+,C+}
    Writeln ('OmegaSoft 6809 Cross Librarian version 3.00') ;
    Writeln ('Copyright 1987, 1989 by Certified Software Corporation') ;
    col := 0 ;
    cparm := 1 ;
    ispec := cline(cparm) ;
    seq := false ;
    if (ispec[0] > 0) and (ispec[1] = '-')
      then
        begin
          cparm := cparm + 1 ;
          if (ispec[0] = 2) and (upshift(ispec[2]) = 'S')
            then
              seq := true
            else
              begin
                writeln ('Command line error, format is :') ;
                writeln ('xlb [-s] output {inputs}') ;
                halt (22)
              end
        end ;
    Rewrite (ofile, sufadd (cline(cparm),'r')) ;
    cparm := cparm + 1 ;
    repeat
      ispec := cline (cparm) ;
      cparm := cparm + 1 ;
      if seq
        then
          begin
            prefix := substr (ispec,1,2) ;
            max := integer (substr(ispec,3,length(ispec)-2))
          end
        else
          max := 1 ;
      for count := max downto 1 do
        begin
          if seq
            then
              iname := Concat(prefix,string(count))
            else
              iname := ispec ;
          iname := sufadd (iname,'r') ;
          {$I-}
          reset (ifile,iname) ;
          If Deverr (ifile) <> 0
            then
              If Deverr (ifile) = FNF
                then
                  begin
                    Writeln ;
                    Writeln (iname,' not found') ;
                    Close (ofile) ;
                    Halt (255)
                  end
                else
                  begin
                    Close (ofile) ;
                    Halt (Deverr(ifile))
                  end ;
          {$I+}
          Write (iname : -12) ;
          col := succ (col) ;
          If (col mod 5) = 0
            then
              Writeln ;
          while not eof (ifile) do
            begin
              Read (ifile,clth) ;
              Write (ofile,clth) ;
              for rcnt := 1 to clth do
                begin
                  Read (ifile,cbyte) ;
                  Write (ofile,cbyte)
                end
            end ;
          close (ifile)
        end
    until (length (cline(cparm)) = 0) or Break ;
    close (ofile) ;
    If (col mod 5) <> 0
      then
        Writeln
  End .
