{$l-}
{ 5/16/89 : initial conversion to version 3 }
  type
    error_type = (:undef,     {so can use as token type}
                  e_it,       {illegal token}
                  e_ic,       {illegal character}
                  e_ii,       {illegal integer}
                  e_ih,       {illegal hex}
                  e_ix,       {illegal longhex}
                  e_il,       {illegal longinteger}
                  e_ir,       {illegal real}
                  e_period,   {. expected}
                  e_id,       {identified expected}
                  e_lpar,     {( paren expected}
                  e_rpar,     {) paren expected}
                  e_eipl,     {error in parameter list}
                  e_semi,     {; expected}
                  e_is,       {invalid string}
                  e_iddt,     {identifier declared twice}
                  e_equal,    {= expected}
                  e_icon,     {invalid constant}
                  e_ui,       {unidentified identifier}
                  e_inac,     {identifier not appropriate class}
                  e_ensm,     {END or ; expected}
                  e_dtdt,     {.. expected}
                  e_eist,     {error in simple type}
                  e_ist,      {incompatible subrange types}
                  e_lbehb,    {low bound exceeds high bound}
                  e_inst,     {invalid subrange type}
                  e_of,       {OF expected}
                  e_lbrk,     {[ bracket expected}
                  e_rbrk,     {] bracket expected}
                  e_eit,      {error in type}
                  e_integ,    {integer expected}
                  e_colon,    {: expected}
                  e_sao,      {stack allocation overflow}
                  e_inmd,     {index type does not match declaration}
                  e_iidx,     {invalid index type}
                  e_eiv,      {error in variable}
                  e_assign,   {:= expected}
                  e_tc,       {type conflict}
                  e_voob,     {value to be assigned is out of bounds}
                  e_itoo,     {illegal type of operand}
                  e_ita,      {invalid type for address}
                  e_zsna,     {zero string not allowed}
                  e_optr,     {operator expected}
                  e_comma,    {, expected}
                  e_espp,     {error in type of standard procedure param}
                  e_usio,     {undeclared or incorrect standard I/O}
                  e_esfp,     {error in type of standard function param}
                  e_itoe,     {illegal type of expression}
                  e_do,       {DO expected}
                  e_then,     {THEN expected}
                  e_npnd,     {number of parameters does not agree}
                  e_ips,      {illegal parameter substitution}
                  e_bte,      {backtrack error}
                  e_fpna,     {file value parameter not allowed}
                  e_todn,     {TO/DOWNTO expected}
                  e_msl,      {max string length is 126}
                  e_tmse,     {too many set elements}
                  e_ibt,      {invalid base type}
                  e_heap,     {heap overflow}
                  e_sto,      {symbol table overflow}
                  e_prog,     {PROGRAM expected}
                  e_cctc,     {case constant type conflict}
                  e_eool,     {exit outside of loop}
                  e_fprd,     {forward pointer reference not defined}
                  e_coos,     {compiler out of sync or no '.'}
                  e_will,     {warning - incorrect lexical level}
                  e_igtl,     {invalid goto to label}
                  e_wcor,     {warning - constant out of range}
                  e_vbo,      {FATAL ERROR - variable buffer overflow}
                  e_fqf,      {forward queue full}
                  e_vqf,      {variable queue full}
                  e_ppqf,     {program parameter queue full}
                  e_se,       {statement expected}
                  e_ifrt,     {invalid function return type}
                  e_begn,     {begin expected}
                  e_iurv,     {invalid use of register variable}
                  e_ecc,      {exception procedures cannot be called}
                  e_warn,     {WARNING - type conversion made}
                  e_etnf,     {exception or task functions not allowed}
                  e_rbo,      {relocatable buffer overflow}
                  e_boor,     {branch out of range}
                  e_ilto,     {internal label table overflow}
                  e_elto,     {external label table overflow}
                  e_mdes,     {multiply defined external symbol}
                  e_invop,    {invalid opcode}
                  e_wgsv      {global stack variable outside of include}
                 ) ;
                
{$l+}
