module vars {$v3,0 variable declaration} ;
{
  5/17/89 : initial conversion to level 3
}
{$I/r0/token}
{$I/r0/code}
{$I/r0/error}
{$I/r0/varib}

  var
    inited : boolean varib entry ;
    
{$I/r0/codeproc}
  procedure scan ; external ;
  function constant (var cerror : error_type) : ^packet ; external ;
  function aconstant (var cerror : error_type) : ^packet ; external ;
  procedure enum_up ; external ;
  procedure error (e : error_type) ; external ;
  function allocate (st : storage_type) : error_type ; external ;
  procedure semilook (e : error_type) ; external ;
  procedure replace (e : error_type ; t : token_type) ; external ;
  procedure symdone (p : ^symhead) ; external ;
  function enter_symbol (s : string[120] ; restrict : boolean ;
                         var headaddr : ^symhead) : boolean ; external ;
  function retadr (pin : ^packet) : ^packet ; external ;
  procedure point_check ; external ;
  procedure typeit (var p : manypt ; var errcode : error_type) ;
                                                      external ;
  function get_internal : hex ; external ;
  function gimme (req : tokes ; var gerror : error_type) : ^packet ; external ;
  function giveit (req : tokes ; var gerror : error_type ;
                   gpac : ^packet) : ^packet ; external ;
  function outexp (var ouerror : error_type) : ^packet ; external ;
 
  function get_next (p1 : ^token_type ; first : boolean) : ^token_type ;
                                                              entry ;
    var
      last : ^token_type register ;
      temp : ^longhex register ;
    begin
      if first
        then
          def_next := 0 ;
      repeat
        get_next := p1 ;
        case p1^ of
          deferred :
            begin
              def_next := succ (def_next) ;
              temp := align(p1 + 1) ;
              p1 := temp^ + align(sizeof(symhead)) ;
              def_point[def_next] := temp + 4 {point to next type}
            end ;
          termit :
            if def_next = 0
              then
                begin
                  get_next := nil ;
                  exit
                end
              else
                begin
                  p1 := def_point[def_next] ;
                  def_next := pred (def_next)
                end
          else
            exit
        end
      until false
    end ;
    
  function init_var (var ierror : error_type ; p1 : ^symhead ; p : manypt ;
                     nflag, rflag : boolean ; var count : hex) : longhex ;
    var
      temp : longhex register ;
      h, range : hex register ;
      lth : byte register ;
      p2 : ^packet ;
      p3 : ^anystring ;
      p4 : ^symhead ;
      def_next : byte ;
      def_point : array [#0..#10] of longhex ;
      last, save : ^longhex ;
      
    function get_more (p1 : ^token_type ; first : boolean) : ^token_type ;
      var
        last : ^token_type register ;
        temp : ^longhex register ;
      begin
        if first
          then
            def_next := 0 ;
        repeat
          get_more := p1 ;
          case p1^ of
            deferred :
              begin
                def_next := succ (def_next) ;
                temp := align(p1 + 1) ;
                p1 := temp^ + align(sizeof(symhead)) ;
                def_point[def_next] := temp + 4 {point to next type}
              end ;
            termit :
              if def_next = 0
                then
                  begin
                    get_more := nil ;
                    exit
                  end
                else
                  begin
                    p1 := def_point[def_next] ;
                    def_next := pred (def_next)
                  end
            else
              exit
          end
        until false
      end ;
      
    begin {init_var}
      ierror := undef ;
      repeat
        if nflag
          then
            begin
              scan ;
              p1^.storage := s_data
            end ;
        if rflag or nflag
          then
            p.tk := p1 + align(sizeof(symhead)) ;
        p.tk := get_more (p.tk, true) ;
        if p.tk = nil
          then
            begin
              ierror := e_bte ;
              exit
            end ;
        count := 1 ;
        if p.tk^ in [boolvar .. sublint, stringvar]
          then
            begin
              p2 := outexp (ierror) ;
              if not p2^.conflag
                then
                  begin
                    ierror := e_icon ;
                    exit
                  end ;
              if lastpack^.token = of_
                then
                  if p2^.token in [integvar, hexvar]
                    then
                      begin
                        count := p2^.pvc_hex ;
                        scan ;
                        p2 := gimme([p.tk^], ierror) ;
                        if ierror <> undef
                          then
                            exit
                      end
                    else
                      begin
                        ierror := e_itoe ;
                        exit
                      end
                else
                  if ierror <> undef
                    then
                      exit
                    else
                      begin
                        p2 := giveit ([p.tk^], ierror, p2) ;
                        if ierror <> undef
                          then
                            exit
                      end ;
              case p.tk^ of
                boolvar, charvar, subbool, subchar, enumvar :
                  for h := 1 to count do
                    begin
                      data_byte (p2^.pvc_char) ;
                      if icode_buf[0] > 110
                        then
                          outterm
                    end ;
                integvar, hexvar, subinteg, subhex :
                  for h := 1 to count do
                    begin
                      data_word (p2^.pvc_hex) ;
                      if icode_buf[0] > 110
                        then
                          outterm
                    end ;
                lhexvar, lintvar, sublint, sublhex, realvar :
                  for h := 1 to count do
                    begin
                      data_long (p2^.pvc_longhex) ;
                      if icode_buf[0] > 110
                        then
                          outterm
                    end ;
                stringvar :
                  begin
                    p3 := p2^.pvc_string ;
                    p.tk := p.tk + 1 ;
                    lth := p.ch^ ;
                    if lth < p3^[0] + 1
                      then
                        begin
                          ierror := e_icon ;
                          exit
                        end ;
                    for h := 1 to count do
                      begin
                        if icode_buf[0] + p3^[0] > 110
                          then
                            outterm ;
                        data_byte (p3^[0]) ;
                        datast (p3^) ;
                        if lth > p3^[0] + 1
                          then
                            begin
                              opcode (c_rmb) ;
                              post1 (p_abs) ;
                              codet_word (hex(lth - p3^[0] - 1))
                            end
                      end ;
                    outterm ;
                  end
              end ;
              if icode_buf[0] > 110
                then
                  outterm
            end
          else
            if p.tk^ = arrayvar
              then
                begin
                  p.tk := align(p.tk + 1) + 2 ;
                  p.tk := get_more(p.tk, false) ;
                  if p.tk = nil
                    then
                      begin
                        ierror := e_bte ;
                        exit
                      end ;
                  case p.tk^ of
                    subbool, subchar, enumvar :
                      begin
                        p.ch := align(p.tk + 1) + 1 ;
                        range := hex (p.ch^) ;
                        p.ch := p.ch + 1
                      end ;
                    subinteg, subhex :
                      begin
                        p.hx := align(p.tk + 1) + 2 ;
                        range := hex(p.hx^) ;
                        p.hx := p.hx + 2
                      end ;
                    sublhex, sublint :
                      begin
                        p.lx := align(p.tk + 1) + 4 ;
                        range := hex(p.lx^) ;
                        p.lx := p.lx + 4
                      end ;
                    boolvar :
                      begin
                        range := 1 ;
                        p.tk := p.tk + 1
                      end ;
                    charvar :
                      begin
                        range := $ff ;
                        p.tk := p.tk + 1
                      end
                    else
                      begin
                        ierror := e_iidx ;
                        exit
                      end
                  end ;
                  if lastpack^.token <> leftparen
                    then
                      begin
                        ierror := e_lpar ;
                        exit
                      end ;
                  scan ;
                  p.tk := get_more (p.tk, false) ;
                  h := 0 ;
                  repeat
                    temp := init_var (ierror, p1, p, false, false, count) ;
                    if ierror <> undef
                      then
                        exit (2) ;
                    h := h + count ;
                    if h - 1 <> range
                      then
                        begin
                          if lastpack^.token <> comma
                            then
                              begin
                                ierror := e_comma ;
                                exit (2)
                              end ;
                          heapptr := heapstart ;
                          scan
                        end ;
                  until h > range ;
                  if h - 1 <> range
                    then
                      begin
                        ierror := e_inmd ;
                        exit
                      end ;
                  if lastpack^.token <> rightparen
                    then
                      begin
                        ierror := e_rpar ;
                        exit
                      end ;
                  p.lx := temp ;
                  scan ;
                  count := 1 ;
                  outterm ;
                end
              else
                if p.tk^ = recordvar
                  then
                    begin
                      mark (save) ;
                      last := nil ;
                      p.tk := align(p.tk + 1) + 2 ;
                      p4 := p.lx^ ; {pointer to last}
                      while p4 <> nil do
                        begin
                          new (last) ;
                          last^ := p4 ;
                          p4 := p4^.nextptr
                        end ; {get pointers in reverse order}
                      if lastpack^.token <> leftparen
                        then
                          begin
                            ierror := e_lpar ;
                            exit
                          end ;
                      scan ;
                      if last <> nil
                        then
                          repeat
                            p4 := last^ ;
                            p.tk := p4 + align(sizeof(symhead)) ;
                            p.tk := init_var (ierror, p4, p, false, true, count) ;
                            if ierror <> undef
                              then
                                exit (2) ;
                            if last <> save
                              then
                                begin
                                  if lastpack^.token <> comma
                                    then
                                      begin
                                        ierror := e_comma ;
                                        exit
                                      end ;
                                  heapptr := heapstart ;
                                  scan
                                end ;
                            last := last - 4
                          until last < save ;
                      if lastpack^.token <> rightparen
                        then
                          begin
                            ierror := e_rpar ;
                            exit
                          end ;
                      scan ;
                      release (save) ;
                      count := 1 ;
                      outterm ;
                    end
                  else
                    begin
                      ierror := e_eiv ;
                      exit
                    end
      until true ;
      init_var := p.lx ;
      if nflag
        then
          begin
            outterm ;
            opcodet (cd_code)
          end
    end ;

  function put_point (var old : ^symname ; current : ^symhead) 
                                          : error_type ; entry ;
    var
      lth : longhex register ;
      p1 : ^longhex register ;
      p2 : ^symname register ;
    begin
      put_point := undef ;
      if pointer_active > old
        then
          begin
            if (pointer_active - old + pointer_active) >
               addr(ptrq) + longhex(size_ptrq)
              then
                put_point := e_fqf
              else
                begin
                  p2 := pointer_active ;
                  p2^ := old^ ; {string}
                  lth := longhex(old^[0]) ;
                  p1 := align (p2 + lth + 1) ;
                  old := p2 ;
                  p1^ := current + align(sizeof(symhead)) + 2 ;
                  pointer_active := p1 + 4
                end
          end
    end ;

  procedure var_decl (reccall : boolean) ; entry ;
    const
      rvloop = 1 ;
      rv10 = 2 ;
      rv10ext = 3 ;
    label
      rv10, rvloop, rv10ext ;
    var
      errcode : error_type ;
      init_ok, dummy : boolean ;
      isentry : boolean register ;
      store : storage_type register ;
      pcount : byte ;
      ttemp : error_type ;
      p : manypt ;
      p1 : ^symhead ;
      p4 : ^symname ;
      p3 : ^packet ;
      p5 : ^token_type register ;
      p6 : ^type_device_head ;
      p7 : ^byte register ;
      ptactive, oldptactive : ^byte ;
      dummy2 : longhex ;
      dummy3 : hex ;
      sel : token_type ;
      nosubs : boolean ;
    begin
      if reccall
        then
          goto rv10 ;
      scan ;
      modif1 := undef ;
      modif2 := undef ;
      if lastpack^.token in [entry_, external_, pcr_, data_ .. varib_]
        then
          begin
            modif1 := lastpack^.token ;
            scan
          end ;
      if lastpack^.token in [entry_, external_]
        then
          begin
            modif2 := lastpack^.token ;
            scan
          end ;
      nesting := succ (nesting) ;
{
  main variable declaration loop
}
rvloop : var_active := var_start ;
      init_ok := true ;
      repeat
        if ident_flag
          then
            if not enter_symbol (last_ident, true, p1)
              then
                begin
                  if (var_active + longhex(last_ident[0] + 1))
                     > (addr(varq) + longhex(size_varq))
                    then
                      begin
                        semilook (e_vqf) ;
rv10ext :               goto rv10
                      end ;
                  var_active^ := last_ident ;
                  var_active := var_active +
                                longhex(last_ident[0] + 1)
                end
              else
                begin
                  semilook (e_iddt) ;
                  goto rv10ext
                end
          else
            begin
              semilook (e_id) ;
              goto rv10ext
            end ;
        scan ;
        if lastpack^.token <> comma
          then
            exit ;
        init_ok := false ;
        scan
      until false ;
      if not (lastpack^.token in [equal,colon,assign])
        then
          begin
            semilook (e_colon) ;
            goto rv10ext
          end ;
      if lastpack^.token <> colon
        then
          replace (e_colon, colon) ;
      if var_active = var_start
        then
          begin
            semilook (e_id) ;
            goto rv10ext
          end ;
      var_current := var_start ;
      if enter_symbol (var_current^, true, p1)
        then
          begin
            semilook (e_iddt) ;
            goto rv10ext
          end ;
      p1^.idgroup := vardef ;
      p.tk := p1 + align(sizeof(symhead)) ;
      errcode := undef ;
      tpstart := p.tk ;
      ptactive := pointer_active ;
      typeit (p, errcode) ;
      if errcode > undef
        then
          begin
            semilook (errcode) ;
            goto rv10ext
          end ;
      p.tk^ := termit ;
      tpend := p.tk ;
      oldptactive := ptactive ;
      store := s_stack ;
      isentry := false ;
      inited := false ;
      if modif1 = undef
        then
          begin
            sel := lastpack^.token ;
            nosubs := true
          end
        else
          begin
            sel := modif1 ;
            nosubs := false
          end ;
      if not record_flag
        then
          case sel of
            at_ :
              begin
                store := s_absolute ;
                scan ;
                if lastpack^.token = lt
                  then
                    begin
                      store := s_direct ;
                      p3 := retadr(constant(errcode))
                    end
                  else
                    p3 := retadr(aconstant(errcode)) ;
                if errcode = undef
                  then
                    varib_address := p3^.pvc_hex
                  else
                    begin
                      semilook (e_ita) ;
                      goto rv10ext
                    end
              end ;
            pcr_ :
              begin
                store := s_pcr ;
                if nosubs
                  then
                    scan
              end ;
            external_ :
              begin
                store := s_external ;
                if nosubs
                  then
                    scan
              end ;
            entry_ :
              begin
                isentry := true ;
                if nosubs
                  then
                    scan
              end ;
            data_ :
              begin
                if nosubs
                  then
                    begin
                      scan ;
                      sel := lastpack^.token ;
                      nosubs := true
                    end
                  else
                    if modif2 = undef
                      then
                        begin
                          sel := lastpack^.token ;
                          nosubs := true
                        end
                      else
                        begin
                          sel := modif2 ;
                          nosubs := false
                        end ;
                case sel of
                  external_ :
                    begin
                      store := s_data_ext ;
                      if nosubs
                        then
                          scan
                    end ;
                  entry_ :
                    begin
                      store := s_data ;
                      isentry := true ;
                      if nosubs
                        then
                          scan
                    end
                  else
                    store := s_data
                end ;
                if (store = s_data) and init_ok and
                   (lastpack^.token = const_)
                  then
                    begin
                      inited := true ;
                      isentry := true
                    end
              end ;
            varib_ :
              begin
                if nosubs
                  then
                    begin
                      scan ;
                      sel := lastpack^.token ;
                      nosubs := true
                    end
                  else
                    if modif2 = undef
                      then
                        begin
                          sel := lastpack^.token ;
                          nosubs := true
                        end
                      else
                        begin
                          sel := modif2 ;
                          nosubs := false
                        end ;
                case sel of
                  external_ :
                    begin
                      store := s_varib_ext ;
                      if nosubs
                        then
                          scan
                    end ;
                  entry_ :
                    begin
                      store := s_varib ;
                      isentry := true ;
                      if nosubs
                        then
                          scan
                    end
                  else
                    store := s_varib
                end
              end
          end ;
      if ((store = s_external) or 
         (store = s_stack) and isentry) and (lex <> 1)
        then
          error (e_will) ;
      repeat
        symdone(p1) ;
        next_sym := align(p.tk + 1) ;
        if ((store = s_data) or (store = s_varib)) and not isentry and
            not inited
          then
            p1^.intname := get_internal ;
        ttemp := allocate (store) ;
        if ttemp <> undef
          then
            begin
              semilook (ttemp) ;
              goto rv10ext
            end ;
        case store of
          s_external, s_data_ext, s_pcr, s_varib_ext :
            begin
              override := true ;
              passt (concat(' xref ',substr(var_current^,1,8))) ;
              override := false
            end ;
          s_stack :
            if isentry
              then
                begin
                  override := true ;
                  passt (concat(' xdef ',substr(var_current^,1,8))) ;
                  opcode (c_equ) ;
                  post1 (p_imm + p_eqea) ;
                  lab (var_current^) ;
                  codet_word (0 - alloc) ;
                  override := false
                end ;
          s_data, s_varib :
            if isentry
              then
                begin
                  override := true ;
                  passt (concat(' xdef ',substr(var_current^,1,8))) ;
                  if inited
                    then
                      begin
                        dummy2 := init_var (ttemp,p1, p, true, false, dummy3) ;
                        if ttemp <> undef
                          then
                            begin
                              semilook (ttemp) ;
                              goto rv10ext
                            end
                      end ;
                  override := false ;
                end
        end ;
        if lex = 1
          then
            begin
              p4 := addr (paramq) ;
              pcount := 1 ;
              while p4 < prog_param do
                if upshift(p4^) = upshift(var_current^)
                  then
                    begin
                      p5 := p1 + align(sizeof(symhead)) ;
                      p5 := get_next (p5, true) ;
                      if p5 = nil
                        then
                          begin
                            semilook (e_bte) ;
                            goto rv10ext
                          end ;
                      if p5^ = devicevar
                        then
                          begin
                            p6 := align (p5 + 1) ;
                            p6^.name_flag := pcount ;
                            exit
                          end
                        else
                          exit
                    end
                  else
                    begin
                      pcount := succ (pcount) ;
                      p4 := p4 + longhex(p4^[0] + 1)
                    end
            end ;
        var_current := var_current + 
                         longhex (var_current^[0] + 1) ; {next name}
        if var_current >= var_active
          then
            exit ;
        if enter_symbol (var_current^, true, p1)
          then
            begin
              semilook (e_iddt) ;
              goto rv10ext
            end ;
        p1^.idgroup := vardef ;
        p.ch := p1 + align(sizeof(symhead)) ;
{
  copy type declaration into duplication variable
}
        p7 := tpstart ;
        while p7 <= tpend do
          begin
            p.ch^ := p7^ ;
            p.ch := p.ch + 1 ;
            p7 := p7 + 1
          end ;
        p.ch := p.ch - 1 ;
        if put_point (oldptactive, p1) <> undef
          then
            begin
              semilook (e_fqf) ;
              goto rv10ext
            end ;
      until false ;
      if not record_flag
        then
          enum_up ;
      heapptr := heapstart ;
      if (lastpack^.token = semicolon) or not record_flag
        then
          begin
            if lastpack^.token <> semicolon
              then
                semilook(e_semi) ;
{
  end of loop entry point used for records
}
rv10 :      scan ;
            if lastpack^.token <> rightparen
              then
                if lastpack^.token in [array_ .. with_]
                  then
                    if not record_flag
                      then
                        begin
                          nesting := pred (nesting) ;
                          enum_up ;
                          point_check
                        end
                      else
                  else
                    goto rvloop
          end
    end ;
    
modend.
